//Includes
//Defines
#define SWITCH_TIME 20
#define DELAY_TIME 0
///Global Variables define
enum KEYS
{
    a1,a2,a3,a4,a5,a6,a7,a8,a9,a0,A,B,C,D,E,F,RET,RUN,LOAD,STORE,WRITE,READIN,READDEC,ADRSSET
};
///Method Prototype define
void WriteDigits(KEYS key);
void EmulateKey(int pinRead,int pinWrite);
void setup()
{
    Serial.begin(115200);
    
    for(int cnt = 5;cnt <= 12;cnt++) 
    {
        pinMode(cnt,INPUT_PULLUP);
        
    }
    for(int cnt = 2;cnt <= 4;cnt++)
    {
        pinMode(cnt,INPUT_PULLUP);
    }
    Serial.println("READY TO INPUT");
}

void loop()
{
    while(Serial.available() > 0) 
    {
        WriteByte(Serial.read());
    }    
}

void WriteByte(char input)
{
    switch(input)
    {
        case '1':

            EmulateKey(11,2);
        break;
        case '2':
            EmulateKey(10,2);
        break;
        case '3':
            EmulateKey(9,2);
        break;
        case '4':
            EmulateKey(8,2);
        break;
        case '5':
            EmulateKey(7,2);
        break;
        case '6':
            EmulateKey(6,2);
        break;
        case '7':
            EmulateKey(5,2);
        break;
        case '8':
            EmulateKey(12,3);
        return;
        case '9':
            EmulateKey(11,3);
        break;
        case '0':
            EmulateKey(12,2);
        return;
        case 'A':
            EmulateKey(10,3);
        break;
        case 'B':
            EmulateKey(9,3);
        break;
        case 'C':
            EmulateKey(8,3);
        break;
        case 'D':
            EmulateKey(7,3);
        break;
        case 'E':
            EmulateKey(6,3);
        break;
        case 'F':
            EmulateKey(5,3);
        break;
        case 'G'://RET
            EmulateKey(11,4);
        break;
        case 'H'://RUN
            Serial.println("H");
            EmulateKey(12,4);
        break;
        case 'I'://LOAD
            EmulateKey(5,4);
        break;
        case 'J'://STORE
            EmulateKey(6,4);
        break;
        case ','://WRITEIN
            EmulateKey(7,4);
        break;
        case 'L'://READIN
            EmulateKey(8,4);
        break;
        case 'M'://READDEC

            EmulateKey(9,4);
        break;
        case 'N'://ADRSSET
            EmulateKey(10,4);
        break;
        default:
        return;
    }
}

//Emulate keyPress DATA from INPUT PIN TO OUTPUT PIN
void EmulateKey(int pinRead,int pinWrite)
{   
    pinMode(pinWrite,OUTPUT);
    long time = millis();
    while(time + SWITCH_TIME >= millis())
    {
        digitalWrite(pinWrite,digitalRead(pinRead));
    }
    pinMode(pinWrite,INPUT_PULLUP);
    //Serial.println("write");
    delay(DELAY_TIME);
    
   /*
    pinMode(pinRead,OUTPUT);
    pinMode(pinWrite,OUTPUT);
    long time = millis();
    while(time + SWITCH_TIME >= millis())
    {
        digitalWrite(pinRead,1digitalRead(pinWrite));
        delay(10);
        //digitalWrite(pinRead,0);

    }
    pinMode(pinRead,INPUT);
    pinMode(pinWrite,INPUT);
    //Serial.println("write");
    delay(DELAY_TIME);
    */
   /*
    pinMode(2,OUTPUT);
    long time = millis();
    while(time + SWITCH_TIME >= millis())
    {
        digitalWrite(2,digitalRead(5));
    }
    pinMode(2,INPUT);
    //Serial.println("write");
    delay(DELAY_TIME);
    */
}
